# -*- coding: utf-8 -*-
# blex - blog extender $Revision: 0.1.2 $
# published 2012-05-09
# for tDiary 3.1.1 to 3.1.3 and blogkit with ruby 1.9.2+
# Copyright (c) 2011-2012 Teruo Kohashi <teruo@kohashi.org>
# Distributed under the GPL

### Blex class ###################################

add_footer_proc do
	<<-HTML
<div class="footer">
Enhanced by <a href="http://www.kohashi.org/dev/blex.html">blex</a>β version 0.1.2<br/>
</div>
	HTML
end

class Blex < TDiary::Plugin #Plugin

def initialize( cgi, diaries, mode, years, date, cache, conf, logger )
	# init
	@cgi = cgi
	@diaries = nil
	@mode = mode
	@years = years
	@date = date # Time class
	@conf = conf
	@index_catdays = cache
	
	@nth = nil
	@related_cats  = []
	@parent_cats = []
	$diaries_days  = nil
	$diaries  = nil
	
	@menu_tabs = ''
	@cat_list = ''
	@path_list = ''
	@page_list = ''
	@side_navi = ''

	init_config

	# start
	return init_fail if @cgi.nil?
	@cat = @cgi.params['blogcategory'][0]
	@day = @cgi.params['date'][0] # String
	@day = @date.strftime( '%Y%m%d' ) if @day.nil? and @date
	@nth = @cgi.params['n'][0]
	@nth = @nth.to_i if @nth
	if /^(day)$/ =~ @mode
		if @cat then init_day_cat else init_day end
	elsif @mode == 'latest'
		if @cat then init_latest_cat else init_latest end
	elsif /^(search|month|showcomment)$/ =~ @mode
		init_others
	end
end

def init_config
	# site info
	@index = @conf.index || './'
	@update = @conf.update || 'update.rb'
	@edit = @conf['blex.edit'] || @update
	@index_page = @conf.index_page
	@html_title = @conf.html_title
	@site_desc = @conf.description
	@site_keys = []

	@latest_limit = ( @conf.latest_limit || 10 ).to_i
	@index_width = ( @conf['blex.index_width'] || 10 ).to_i
	@items_limit = ( @conf['blex.items_limit'] || 60 ).to_i

	@show_only_count = @conf['blex.show_only_count'].to_i == 1 ? true : false # 0: default; 1: show page count
	@cat_desc_page = @conf['blex.cat_desc_page'] # category description page

	@url_serial = @conf['blex.url_serial'].to_i == 1 ? true : false # 0: default; 1: use serial type day format
	@url_rewrite = @conf['blex.url_rewrite'].to_i == 1 ? true : false # 0: default; 1: rewrite on
	# set menu options
	@menu_select_by_paramcat = @conf['blex.menu_select_by_paramcat'].to_i == 1 ? true : false # 0: default; 1: select with related cats
	@hide_blank_paged_cat = @conf['blex.hide_blank_paged_cat'].to_i == 1 ? true : false # 0: default; 1: hide blank page cat 存在しないページのカテゴリを非表示
	@hide_no_menued_cat = @conf['blex.hide_no_menued_cat'].to_i == 1 ? true : false # メニューにないカテゴリを非表示

	set_menu_tree
	if @menu_tree
	 	@tdiary_top_label  = @conf['blex.top_label']  || @menu_tree[0][0] || 'HOME'
		@tdiary_top_catday = @conf['blex.top_catday'] || @menu_tree[0][1] || 'index'
		set_menued_cats
		set_parent_cats
	else
	 	@tdiary_top_label  = @conf['blex.top_label']  || 'HOME'
		@tdiary_top_catday = @conf['blex.top_catday'] || 'index'
		@hide_no_menued_cat = false
		@menued_cats   = []
		@parent_cats   = []
	end
	
	if @index_catdays
		@mulpaged_cats = set_mulpaged_cats
	else
		@hide_single_paged_cat = false
		@hide_blank_paged_cat = false
		@show_only_count = false
		@mulpaged_cats = []
	end
end

def init_fail
	set_menu_tabs
end

def init_day
	@day = @date.strftime( '%Y%m%d' ) if @date # YYYYMMDD-10
	diary_cats = get_diary_cats( @day )
	@related_cats = get_member_cats( diary_cats ) + diary_cats
	group_days = get_latest_days( @items_limit )
	set_path_list( [ @tdiary_top_catday ] ) #, ' /' )
	set_diaries_navi( day: @day, days: group_days, title: "最新の #{group_days.size} ページ" )
	set_menu_tabs
	set_cat_list( diary_cats )
end

def init_latest
	@day = @date.strftime( '%Y%m%d' ) if @date # when day YYYYMMDD-10 format
	@related_cats = []
	group_days = get_latest_days( @items_limit )
	set_path_list( [ @tdiary_top_catday ] ) #, ' /' )
	nth = group_days.index(@day)
	set_diaries_navi( nth: @nth, days: group_days, title: "最新の #{group_days.size} ページ" )
	set_menu_tabs
	set_cat_list
end

def init_day_cat
	diary_cats = get_diary_cats( @day )
	
	# TOP(1)
	if @parent_cats.include?( @cat ) and @index_catdays[@cat].size == 1
		member_cats = get_member_cats( @cat )
		@related_cats = member_cats + diary_cats
		group_days = get_group_days( member_cats )
		#throw if group_days.index(@day).nil?
		@path_list = set_path_list( [ @tdiary_top_catday, @cat ] )
		set_diaries_navi( mode: 'nomenunavi', cat: @cat, day: @day, days: group_days ) #, title: "[#{cats_link(@cat)}]" )

	# TOP(2+)
	elsif @parent_cats.include?( @cat )
		member_cats = get_member_cats( @cat )
		@related_cats = member_cats + diary_cats
		group_days = get_group_days( @cat )
		@path_list = set_path_list( [ @tdiary_top_catday, @cat ] ) #, ' /' )
		set_diaries_navi( mode: 'secnum', cat: @cat, day: @day, days: group_days ) #, title: "[#{cats_link(@cat)}]" ) # @cat is top but not group

	# menued cat(1)
	elsif @menued_cats.include?( @cat ) and @index_catdays[@cat].size == 1
		member_cats = get_member_cats( @cat )
		@related_cats =member_cats + diary_cats
		group_days = get_group_days( member_cats )
		parent_cat = get_parent_cats(@cat)[0]
		@path_list = set_path_list( [ @tdiary_top_catday, parent_cat, @cat ] )
		set_diaries_navi( mode: 'nomenunavi', cat: parent_cat, day: @day, days: group_days ) #, title: "[#{cats_link(parent_cat)}]" )

	# menued cat(2+)
	elsif @menued_cats.include?( @cat )
		member_cats = get_member_cats( @cat )
		@related_cats = member_cats + diary_cats
		group_days = get_group_days( @cat )
		parent_cat = get_parent_cats([@cat] + diary_cats)[0]
		@path_list = set_path_list( [ @tdiary_top_catday, parent_cat, @cat ] ) #, ' /' )
		set_diaries_navi( mode: 'secnum', cat: @cat, day: @day, days: group_days ) #, title: "[#{cats_link(@cat)}]" )
	
	# unmenued cat(2+)
	elsif @index_catdays[@cat].size > 1
		@related_cats = diary_cats
		group_days = get_group_days( @cat )
		parent_cat = get_parent_cats([@cat] + diary_cats)[0]
		if parent_cat.nil?
			@path_list = set_path_list( [ @tdiary_top_catday, @cat ] ) #, ' /' )
		else
			@path_list = set_path_list( [ @tdiary_top_catday, parent_cat, @cat ] ) #, ' /' )
		end
		set_diaries_navi( mode: 'secnum', cat: @cat, day: @day, days: group_days ) #, title: "[#{cats_link(@cat)}]" )
		
	# unmenued cat(1)
	else
		@related_cats = [@cat] + diary_cats + get_member_cats( diary_cats )
		@cat = ( diary_cats & @menued_cats )[0] #???
		group_days = get_group_days( @cat )
		parent_cat = get_parent_cats( @cat )[0]
		if parent_cat.nil?
			@path_list = set_path_list( [ @tdiary_top_catday, @cat ] ) #, ' /' )
		else
			@path_list = set_path_list( [ @tdiary_top_catday, parent_cat, @cat ] ) #, ' /' )
		end
		set_diaries_navi( cat: @cat, day: @day, days: group_days ) #, title: "[#{cats_link(@cat)}]" )
	end
	set_menu_tabs
	set_cat_list( diary_cats )

end

def init_latest_cat
	# TOP(0)
	if @parent_cats.include?( @cat ) and @index_catdays[@cat].nil?
		@related_cats = get_member_cats( @cat ).uniq.compact
		group_days = get_group_days( @related_cats )
		set_path_list( [ @tdiary_top_catday, @cat ] ) #, ' /' )
		set_diaries_navi( cat: @cat, nth: @nth || 0, days: group_days ) #, title: "[#{cats_link(@cat)}]" )

	# TOP(1) -> day mode
	elsif @parent_cats.include?( @cat ) and @index_catdays[@cat].size == 1
	
	# TOP(2+)
	elsif @parent_cats.include?( @cat )
		@related_cats = get_member_cats( @cat ).uniq.compact
		group_days = get_group_days( @cat )
		set_path_list( [ @tdiary_top_catday, @cat ] ) #, ' /' )
		set_diaries_navi( mode: 'secnum', cat: @cat, nth: @nth || 0, days: group_days ) #, title: "[#{cats_link(@cat)}]" )
	
	# menued cat(0)->search
	elsif @menued_cats.include?( @cat ) and ( @index_catdays[@cat].nil? or @index_catdays[@cat].size == 1 )
	
	# unmenued cat(1) -> day mode
	elsif @index_catdays[@cat].nil? or @index_catdays[@cat].size == 1
	
	# menued cat(2+)
	elsif @menued_cats.include?( @cat )
		@related_cats = get_member_cats( @cat ).uniq.compact
		group_days = get_group_days( @cat )
		set_path_list( [ @tdiary_top_catday, get_parent_cats(@cat)[0], @cat ] ) #, ' /' )
		set_diaries_navi( mode: 'secnum', cat: @cat, nth: @nth || 0, days: group_days ) #, title: "[#{cats_link(@cat)}]" )
		
	# unmenued cat(2+)
	else
		@related_cats = get_member_cats( @cats ) + [@cat]
		group_days = get_group_days( @cat )
		parent_cat = get_parent_cats(@cat)[0]
		if parent_cat.nil?
			@path_list = set_path_list( [ @tdiary_top_catday, @cat ] ) #, ' /' )
		else
			@path_list = set_path_list( [ @tdiary_top_catday, parent_cat, @cat ] ) #, ' /' )
		end
		set_diaries_navi( cat: @cat, day: @day, days: group_days ) #, title: "[#{cats_link(@cat)}]" )
		
	end
	
	set_menu_tabs
	set_cat_list
end

def init_others
	group_days = get_latest_days( 10 )
	set_path_list( [ @tdiary_top_catday ] )#, ' / *' )
	set_diaries_navi( days: group_days, title: "最新の #{group_days.size} ページ" )
	set_menu_tabs
end

### set navigations ##############################

def set_menu_tabs
	return '' if @menu_tree.nil? or @menu_tree.empty?
	
	select_cats = @related_cats.uniq.compact || []
	menu = @menu_tree
	
	result = ''
	result << "<ul>\n"	unless @conf.mobile_agent?
	if menu
		menu.each{ |i|
			label = i[0]
			link = i[1]
			cats = ( i[2].nil? or i[2].empty? ) ? [] : i[2]
			active = nil
			active   = 'selected' if @cat == link
			active ||= 'selected'  if cats.include?( @cat )
			active ||= 'related'  if cats and !( cats & select_cats ).empty?
			url = ''
			if link.nil? or link.empty? # link as blogcategory text
				url = diary_url( cat: cats[0] )
			elsif link == '*INDEX*'
				url = @index_page.empty? ? diary_url( ) : diary_url( url: @index_page )
			elsif link == '*LATEST*'
				url = diary_url( nth: 0 )
				active = 'selected' if @cat.nil? #@mode == 'latest' and @cat.nil?
			elsif @index_catdays and @index_catdays[link]
				url = diary_url( cat: link )
			elsif /^\d{8}$/ =~ link # diary day format
				url = diary_url( day: link )
			elsif /(^http)/ =~ link # url format
				 url = "#{link}" # url link
			elsif /(\.|\/|\.html|\.htm|\.rb|\.cgi)/ =~ link # url format
				 url = "#{@index}#{h link}" # relative url link
			else
				url = diary_url( cat: link )
			end
			if active
				if @conf.mobile_agent?
					result << "|<a href='#{url}'>#{h label}</a>| "
				else
					result << "<li><a href='#{url}' class='#{active}'>#{h label}</a></li>\n"
				end
			else
				if @conf.mobile_agent?
					result << "<a href='#{url}'>#{h label}</a> "
				else
					result << "<li><a href='#{url}'>#{h label}</a></li>\n"
				end
			end
		}
	end
	result << "</ul>" unless @conf.mobile_agent?
	result << "\n"
	@menu_tabs = result
end

def set_path_list( cats, post=nil )
	result = ''
	links = []
	label = nil
	cats.uniq.compact.each { |cat|
		link = "#{diary_link( label:cat_label(cat), daycat: cat )}" # 2012-03-07
		if @conf.mobile_agent?
			links << link
		else
			links << "<p>#{link}</p>"
		end
	}
	if @conf.mobile_agent?
		result << links.join('/')
		result << post if post
	else
		result << links.join('<p>/</p>')
	result << "<p>#{h post}</p>" if post
	end
	@path_list = result
end

def set_cat_list( cats=[] )
	return '' if @related_cats.empty?
	related_cats = @related_cats.uniq.compact

	related_cats -= ( cats - @mulpaged_cats ) if !cats.empty? and !@mulpaged_cats.empty? # 自ページが単独カテゴリであれば、カテゴリに入れない
	related_cats -= @parent_cats
	related_cats &= @menued_cats if @hide_no_menued_cat
	related_cats &= @index_catdays.keys if @hide_blank_paged_cat

	result = ''
	result << "<ul>\n" unless @conf.mobile_agent?
	related_cats.each{ |cat|
		label = cat
		label << "*" if @parent_cats.include?( cat )
		if @index_catdays
			if @index_catdays[cat]
				n = @index_catdays[cat].size
			else
				n = 0
			end

			if @show_only_count
				label = "#{label}(#{n})"
			elsif n == 0
				label = "(#{label})"
			elsif n == 1
				label = "#{label}"
			else
				label = "#{label}(#{n})"
			end
		end
		if @conf.mobile_agent?
			result << ( n == 0 ? "#{h label}\n" : "#{diary_link( label: label, cat: cat )}\n" )
		else
			result << ( n == 0 ? "<li>#{h label}</li>\n" : "<li>#{diary_link( label: label, cat: cat )}</li>\n" )
		end
	}
	result << "</ul>" unless @conf.mobile_agent?
	@cat_list = result
end

# set @diaries, @page_list, @side_navi
def set_diaries_navi( opt={} ) # mode, day, cat, nth, days
	mode = opt[:mode] # secnum, nomenunavi
	if opt[:title].nil?
		title = ''
	elsif @conf.mobile_agent?
		title = opt[:title] + '<BR>'
	else
		title = "<p>#{opt[:title]}</p>"
	end
	day = opt[:day]
	cat = opt[:cat]
	nth = opt[:nth]
	days = opt[:days]
	return nil if days.nil? or days.empty?
	days = days.sort.reverse
	nmax = days.size - 1

	nth = days.index(day) if days and day # 2012-03-26
	
	if mode == 'nomenunavi'
	
	elsif nmax < @latest_limit and mode == 'secnum'
		navi_days = sort_by_secnum_days( days )
		@page_list = title + set_secnum_page_list( day, navi_days )
	elsif @mode == 'day'# or @conf.mobile_agent? # 2012-03-07
		nth = days.index(day) || 0
		@page_list = title + set_page_list( nth: nth, days: days, step: 1 )
	else
		@page_list = title + set_page_list( nth: nth, days: days, step: @latest_limit )
	end
	
	navi_days ||= days[ ( (nth || 0) / @latest_limit ) * @latest_limit, @latest_limit ] if days
	update_diaries( navi_days ) if days
	set_side_navi( day: day, cat:cat, parent_cat:parent_cat, days: navi_days )
end

def set_side_navi( opt={} ) # day, cat, days length
	selected_day = opt[:day]
	cat = opt[:cat]
	days = opt[:days] || [] # 008 2012-03-05
	length = opt[:length] || 40
	result = ''
	if cat
		result << "<h3>関連ページ [#{cats_link( cat )}]</h3>\n"
	else
		result << "<h3>最新のページから</h3>\n"
	end
	result << "<ul>"
	days.each { |day|
		if selected_day == day
			result << "<li>⇒#{diary_title( day, length-1 )}</li>\n"
		else
			result << "<li>#{diary_link( day: day, cat: cat, length: length )}</li>\n"
		end
		}
	result << '</ul>'
	@side_navi = result
end

def set_secnum_page_list( day, days )

	nn = days.index( day ) || 0
	if @mode != 'day'
		p = 0
		n = 1
	elsif nn == 0
		p = nil
		n = 1
	elsif nn > days.size
		p = nn -1
		n = nil
	else
		p = nn - 1
		n = nn + 1
	end
	@prev_diary_url = p ? diary_url( day: days[p], cat: @cat ) : nil
	@header_prev_link = p ? "<link rel='prev' title='#{h diary_title( days[p] )}' href='#{@prev_diary_url}'>\n" : nil
	@next_diary_url = n ? diary_url( day: days[n], cat: @cat ) : nil
	@header_next_link = n ? "<link rel='next' title='#{h diary_title( days[n] )}' href='#{@next_diary_url}'>\n" : nil

	result = ''
	result << "<p>ページ:</p>"
	result << "<p><a href='#{@prev_diary_url}'>&lt;</a></p>\n" if @prev_diary_url
	days.each_with_index { |day, i|
		label = stripped_title( diary_title( day ) ).scan(/^\s*([0-9][0-9a-zA-Z\(\)\.-]+)\s.*$/).flatten[0]
		if @day == day and @mode == 'day'
			result << "<p>|#{label || (i+1).to_s}|</p>\n"
		else
			if label
				result << "<p>#{diary_link( day: day, label: label, pre: '[', post: ']', cat: @cat )}</p>\n"
			else
				result << "<p>#{diary_link( day: day, label: (i+1).to_s, cat: @cat )}</p>\n"
			end
		end
	}
	result << "<p><a href='#{@next_diary_url}'>&gt;</a></p>\n" if @next_diary_url

	if @conf.mobile_agent?
		result.gsub(/<\/?p>/i, '')
	else
		result
	end
end

def set_page_list( opt={} ) # nth, nmax, step, width
	nth = opt[:nth]
	days = opt[:days]
	return '' if days.nil? or days.empty?
	nmax = days.size - 1
	step = opt[:step] || 1
	width = opt[:width] || 10
	width = 6 if width < 6

	mode = 'day' if step == 1 or @mode == 'day'
	nn = ( nth || 0 ) / step
	mm = nmax / step
	
	start = nn - ( width / 2 )
	limit = nn + ( width / 2 )
	if start < 0
		start = 0
		limit = [ width, mm ].min
	elsif limit > mm
		start = limit - width
		limit = mm
	end
	
	p = (nn-1)*step
	@prev_diary_url = nil
	@header_prev_link = nil
	if p >= 0
		day = step == 1 ? days[p] : nil
		@prev_diary_url = diary_url( mode: mode, day: day, cat: @cat, nth: p )
		@header_prev_link = "<link rel='prev' title='#{h diary_title( days[p] ) }' href='#{@prev_diary_url}'>\n" if @prev_diary_url
	end
	
	n = (nn+1)*step
	@next_diary_url = nil
	@header_next_link = nil
	if n < nmax
		day = step == 1 ? days[n] : nil
		@next_diary_url = diary_url( mode: mode, day: day, cat: @cat, nth: n )
		@header_next_link = "<link rel='next' title='#{h diary_title( days[n] ) }' href='#{@next_diary_url}'>\n" if @next_diary_url
	end
	
	result = ''
	if step == 1
		result << "<p>ページ:</p>"
	elsif step > 1 and mm == 0
		if @conf.mobile_agent?
			return "一覧 次ページはありません。"
		elsif @conf.smartphone?
			return "<p>一覧 次ページはありません。</p>"
		else
			return "<p>一覧(#{((nmax+1) % step).to_s}件) 次ページはありません。</p>"
		end
	else
		list_size = nn < mm ? step : ( nmax ) % step + 1
		if @conf.mobile_agent?
			result << "一覧:"
		elsif @conf.smartphone?
			result << "<p>一覧:</p>"
		else
			result << "<p>一覧 (#{list_size.to_s}件):</p>"
		end
	end
	result << "<p><a href='#{@prev_diary_url}'>&lt;</a></p>\n" if @prev_diary_url
	day = step == 1 ? days[0] : nil
	if start == 1
		result << "<p>#{diary_link( mode: mode, label: 1, day: day, cat: @cat )}</p>\n"
	elsif start >= 2
		result << "<p>#{diary_link( mode: mode, label: 1, day: day, cat: @cat )}</p><p>...</p>\n"
	end
	nn = nil if nth.nil?
	for i in start..limit
		if i == nn
			result << "<p>|#{i+1}|</p>\n"
		else
			day = step == 1 ? days[i * step] : nil
			result << "<p>#{diary_link( mode: mode, label: i+1, day: day, cat: @cat, nth: i * step )}</p>\n"
		end
	end
	if limit == mm - 1
		day = step == 1 ? days[mm * step] : nil
		result << "<p>#{diary_link( mode: mode, label: mm+1, day: day, cat: @cat, nth: mm * step )}</p>\n"
	elsif limit <= mm - 2
		day = step == 1 ? days[mm * step] : nil
		result << "<p>...</p><p>#{diary_link( mode: mode, label: mm+1, day: day, cat: @cat, nth: mm * step )}</p>\n"
	end
	result << "<p><a href='#{@next_diary_url}'>&gt;</a></p>\n" if @next_diary_url
	if @conf.mobile_agent?
		result.gsub(/<\/?p>/i, '')
	else
		result
	end
end

### diary and index_catdays handlings ############

def update_diaries( days )
	return nil if days.nil? or days.empty?
	$diaries_days = days
	yms = []
	days.each{ |day| yms << day[0,6] }
	yms = yms.uniq
	@diaries.clear if @diaries
	cgi = CGI.new
	def cgi.referer; nil; end
	yms.each { |ym|
		yy = ym[0,4]
		mm = ym[4,2]
		if @years[yy] and @years[yy].include?(mm)
			cgi.params['date'] = [ym]
			#m = TDiaryMonth.new(cgi, '', @conf)
			m = TDiaryMonthWithoutFilter.new(cgi, '', @conf) #!!
			m.diaries.delete_if { |day, diary|
				!days.include?(day)
			}
			if @diaries
				@diaries.update( m.diaries )
			else
				@diaries = m.diaries
			end
		end
	}
	$diaries = @diaries
end

def get_diary( day )
	return nil if day.nil?
	return @get_diary_result if day == @get_diary_day
	@get_diary_day = day
	begin
		day = day.strftime( '%Y%m%d' ) if day.kind_of?(Time)
	rescue
		return @get_diary_result = nil
	end
	return @get_diary_result = nil if day.size != 8
	
	return @get_diary_result = @diaries[day]  if @diaries  and @diaries[day]
	return @get_diary_result = @diaries2[day] if @diaries2 and @diaries2[day]

	ym = day[0,6]
	yy = ym[0,4]
	mm = ym[4,2]
	if @years[yy] and @years[yy].include?(mm)
		cgi = CGI.new
		def cgi.referer; nil; end
		cgi.params['date'] = [ym]
		#m = TDiaryMonth.new(cgi, '', @conf)
		m = TDiaryMonthWithoutFilter.new(cgi, '', @conf) #!!
		if @diaries2
			@diaries2.update(m.diaries)
		else
			@diaries2 = m.diaries
		end
		return @get_diary_result = @diaries2[day] if @diaries2 and @diaries2[day]
	end
	nil
end

def get_latest_days( limit=@items_limit )

	cgi = CGI::new
	def cgi.referer; nil; end

	days = []
	count = 0
	catch(:exit) {
		@years.keys.sort.reverse_each { |yy|
			@years[yy].sort.reverse_each { |mm|
				cgi.params['date'] = ["#{yy}#{mm}"]
				m = TDiaryMonthWithoutFilter::new(cgi, '', @conf)
				m.diaries.keys.sort.reverse_each { |day|
					next if !m.diaries[day].visible?
					days << day
					count += 1
					throw :exit if count >=	limit
				}
			}
		}
	}
	days.uniq.compact
end

def set_mulpaged_cats
	return [] if @index_catdays.nil?
	cats = []
	@index_catdays.keys.each { |cat|
		cats << cat if @index_catdays[cat].keys.size > 1
	}
	@mulpaged_cats = cats.compact.uniq
end

### menu group handlings #########################

def set_menu_tree
	menu_tree = []
	begin
		menu = BLEX_MENU
		return nil if menu.nil?
		menu.each_line {|line|
			m = line.split(nil)
			next if m.empty?
			label = m[0]
			link = m[1]
			member_cats = m[2..-1]
			menu_tree <<  [ label, link, member_cats ]
		}
	rescue
		return nil
	end
	return nil if menu_tree.empty?
	@menu_tree = menu_tree
end

def set_menued_cats
	cats = []
	menu = @menu_tree
	return [] if menu.nil?
	menu.each { |i|
		cats << i[1] if i[1] # parent cat
		cats += i[2] if i[2] # children or group cat
	}
	@menued_cats = cats.compact.uniq
end

def set_parent_cats
	cats = []
	menu = @menu_tree
	return [] if menu.nil?
	menu.each{ |i|
		cats << i[1] if i[1]
	}
	@parent_cats = cats.compact.uniq
end

def get_parent_cats( cats )
	menu = @menu_tree
	return [] if menu.nil?
	cats = [ cats ].flatten.compact
	cats &= @menued_cats
	parent_cats = []
	menu.each{ |i|
		parent_cats << i[1] if cats.include?( i[1] )
		parent_cats << i[1] if !( cats & i[2] ).empty?
	}
	parent_cats.uniq.compact
end

def cat_label( cat, pre=nil, post=nil )
	return '' if cat.nil? or cat.empty?
	return '' if @menu_tree.nil? #008 2012-03-05
	unless @parent_cats.include?( cat )
		label = cat
	else
		menu = @menu_tree
		menu.each{ |i|
			if i[1] == cat
				label = i[0]
				break
			end
		}
	end
	return ( pre || '' ) + label + ( post || '' )
end

def get_member_cats( cats )
	return [] if cats.nil? or cats.empty?
	menu = @menu_tree
	return [] if menu.nil?
	cats = [ cats ].flatten.compact
	cats &= @menued_cats
	member_cats = []
	menu.each{ |i|
		next if i[2].nil? or i[2].empty?
		if cats.include?(i[1]) or !(i[2] & cats).empty?
			member_cats |= i[2]
		end
	}
	( member_cats - @parent_cats ).compact.uniq
end

def get_group_days( cats )
	return [] if cats.nil? or cats.empty?
	return [] if @index_catdays.nil?
	cats = [ cats ].flatten.compact
	days = []
	( cats & @index_catdays.keys ).each{ |cat|
		days += @index_catdays[cat].keys
	}
	days.compact.uniq.sort.reverse
end

def sort_by_secnum_days( days )
	return [] if days.nil? or days.empty?
	days = days.map{|day|
		title = stripped_title( diary_title( day ) ) || ''
		label = title.scan(/^\s*([0-9][0-9a-zA-Z\(\)\.-]+)\s.*$/).flatten[0]
		[ label, day, title ]
	}
	days.sort!{ |a, b|
		if a[0].nil? and b[0].nil?
			b[1] <=> a[1]
		elsif a[0].nil? and b[0]
			+1
		elsif a[0] and b[0].nil?
			-1
		else
			a[0] <=> b[0]
		end
	}
	days.map { |d| d[1] }
end

### title handlings ##############################

def stripped_title( title )
	return '' if title.nil? or title.empty?
	title.sub(/^(\[.+\])+/,'').sub(/\(\d{4}[\-\/年]\s?\d\d?[\-\/月]\s?\d\d?日?\)/,'').gsub(/\s+/, ' ').strip
end

def title_to_cats( title )
	return [] if title.nil? or title.empty?
	cat = /^(\[([^\[]+?)\])+/.match(title).to_a[0]
	return [] if cat.nil?
	cat.scan(/\[(.*?)\]/).collect { |c|
		c[0].split(/,/)
	}.flatten
end

def title_to_cats_title( title )
	cats = title_to_cats( title )
	title = stripped_title( title )
	return cats, title
end

def diary_title( day, length=nil )
	return nil if day.nil? or day.empty?
	diary = get_diary( day )
	return nil if diary.nil?
	title = diary.title.sub(/^(\[.+\])+/,'').sub(/\(\d{4}[\-\/年]\s?\d\d?[\-\/月]\s?\d\d?日?\)/,'').gsub(/\s+/, ' ').strip
	title = '《タイトルなし》' if title.empty?
	
	if length
		result = @conf.shorten( title, length )
	else
		result = title
	end
	result
end

def get_diary_cats( day )
	return [] if day.nil?
	diary = get_diary( day )
	diary ? title_to_cats( diary.title ) : []
end

def get_date( strs )
	return nil if strs.nil? or strs.empty?
	
	date = nil
	strs = [ strs ] if strs.kind_of?( String )
	strs.each{ |str|
		begin
			if /(\d{4})[\/\-年]\s?(\d{1,2})[\/\-月]\s?(\d{1,2})日?/ =~ str
				date = Time.local( $1, $2, $3 )
			elsif /(\d{4})-(\d\d)(\d\d)/ =~ str
				date = Time.local( $1, $2, $3 )
			elsif /(\d{4})年\s?(\d{1,2})月/ =~ str
				date = Time.local( $1, $2, 1 )
			end
		rescue
		end
		return date if date
	}
	date
end


### link handlings ###############################

def diary_url( opt={} ) # mode, day, cat, parent_cat, nth, other
	mode = opt[:mode]
	withoutindex = opt[:withoutindex]
	day = opt[:day]
	cat = opt[:cat]
	nth = opt[:nth]
	other = opt[:other]
	cat = nil if other # !!! commentなどの場合、blogcategoryを無視
	# catがdiary_catある、そのまま
	# catがdiary_catのparent_cat、そのまま
	# catが、diary_catにない、最初のdiary_cat
	diary_cats = get_diary_cats( day ) if day
	if diary_cats.nil?
	 # cat is okl
	elsif diary_cats.empty?
		cat = nil
	elsif diary_cats.include?( cat )
	 # cat is ok
	else
		cat = ( get_member_cats( cat ) & diary_cats )[0]
	end
	if day
		if day.kind_of?(Time)
			day = day.strftime( '%Y%m%d' ) unless @url_serial
			day = day.to_i.to_s if @url_serial
		elsif day.kind_of?(String) and /^\d{8}$/ =~ day and @url_serial
			begin
				day = Time.local( day[0,4].to_i, day[4,2].to_i, day[6,2].to_i ).to_i.to_s
			rescue
			end
		end
	end
	nth = nil if day # 2012-03-08
	results = []
	results << "d=#{u day}" if day and @url_serial
	results << "date=#{u day}" if day and !@url_serial
	results << "##{u other}" if day and other
	results << "c=#{u cat}" if cat and @url_serial
	results << "blogcategory=#{u cat}" if cat and !@url_serial
	results << "n=#{u nth}" if nth
	base = (withoutindex == true) ? '' : h( @index )
	return "" if results.empty?
	return "#{base}#{u day}.html" if @url_rewrite and day and nth.nil? and cat.nil? and other.nil?
	return "#{base}#{u day}.html##{other}" if @url_rewrite and day and nth.nil? and cat.nil? and other
	return "#{base}#{u cat}.html" if @url_rewrite and day.nil? and nth.nil? and cat
	"#{base}?#{results.join(';')}"
end

def latest_url( opt={} )
	opt[:title] ||= '最新'
	opt[:nth] = 0
	diary_url( opt )
end

def home_url( opt={} )
	opt[:title] ||= 'HOME'
	diary_url( opt )
end

def diary_link( opt={} ) # mode, url, day, daycat, cat, pre, post, label, nth, length
	mode = opt[:mode]
	url = opt[:url]
	day = opt[:day]
	daycat = opt[:daycat]
	cat = opt[:cat]
	pre = opt[:pre]
	post = opt[:post]
	label = opt[:label]
	nth = opt[:nth]
	length = opt[:length]
	
	if daycat
		if /^\d{8}.*/ =~ daycat
			day = daycat
		else
			cat = daycat
		end
	end
	if day.nil? and label.nil? and cat
		label = cat
	end
	if day and label.nil?
		label = diary_title( day, length )
	end
	label = ( pre || '' ) + h( label || '' ) + ( post || '' )
	opt[:day] = day
	opt[:cat] = cat
	opt[:nth] = nth
	"<a href='#{diary_url( opt )}'>#{label}</a>"
end

def cats_link( cats, pre=nil, post=nil, after=nil )
	return '' if cats.nil?
	cats = [ cats ].flatten.compact
	return '' if cats.empty?

	result = ''
	cats.each { |cat|
		result << "#{pre || ''}#{diary_link( cat: cat, label: cat_label( cat ) )}#{post || ''}"
	}
	result << after if after
	result
end

### plugin main programs #########################

### html headers

def index_page_tag
	result = ''
	result << @header_prev_link if @header_prev_link
	result << @header_next_link if @header_next_link
	result
end

### navigations for pc and smart phone

def menu_tabs
	@menu_tabs
end

def side_navi
	@side_navi
end

def menu_navi_day
	result = ''
	result << @path_list
	result << '<p>|</p>' + @cat_list if @cat_list and !@cat_list.empty?
	result << "<hr style='clear:both'>" + @page_list if @page_list and !@page_list.empty?
	
	result
end

def footer_navi
	result = '<div class="footer_navi">'
	result << @path_list
	if @page_list.empty?
		result << '<p>|</p>' + @cat_list
	else
		result << '<p>|</p>' + @page_list
	end
	
	result << "<hr style='clear:both'>"
	result << "<p><a href='#{diary_url(cat: $blex_start)}' accesskey='7'>7:#{cat_label($blex_start)}</a><p>" if $blex_start
	result << "<p><a href='#{h @index}?n=0' accesskey='0'>0:&lt;&lt;最新</a></p>"
	result << "<p><a href='#{@prev_diary_url}' accesskey='1'>1:&lt;前</a></p>" if @prev_diary_url
	result << "<p><a href='#{@next_diary_url}' accesskey='3'>3:&gt;次</a></p>" if @next_diary_url
	result << "<p><a href='#{h @edit}?edit=true;year=#{@date.year};month=#{@date.month};day=#{@date.day}' accesskey='5'>5:編集</a></p>" if @mode == 'day'
	result << "<p><a href='#{h @edit}' accesskey='A'>6:追記</a></p>" if /^(day|latest)$/ =~ @mode
	result << "<p><a href='#{h @update}?conf=default' accesskey='C'>9:設定</a></p>"
	
	result << "</div>"
	
	result
end

### navigations for mobile phone

def mobile_navi
	result = ''
	result << '<HR>'
	result << @menu_tabs
	result << '<HR>' + @path_list if @path_list and !@path_list.empty?
	result << '|' + @cat_list if @cat_list and !@cat_list.empty?
	result << '<HR>' + @page_list if @page_list and !@page_list.empty?
	result
end

def mobile_footer_navi
	result = ''
	
	result << '<HR>' + @path_list if @path_list and !@path_list.empty?
	result << '<HR>'
	result << "|<A HREF='#{diary_url(cat: $blex_start)}' ACCESSKEY='7'>7:#{cat_label($blex_start)}</A>" if $blex_start
	result << "|<A HREF='#{h @index}?n=0' ACCESSKEY='0'>0:&lt;&lt;最新</A>"
	result << "|<A HREF='#{@prev_diary_url}' ACCESSKEY='*'>*:&lt;前</A>" if @prev_diary_url
	result << "|<A HREF='#{@next_diary_url}' ACCESSKEY='#'>#:&gt;次</A>" if @next_diary_url
	result << "|<A HREF='#{h @edit}?edit=true;year=#{@date.year};month=#{@date.month};day=#{@date.day}' ACCESSKEY='5'>5:編集</A>" if @mode == 'day'
	result << "|<A HREF='#{h @edit}' ACCESSKEY='6'>6:追記</A>" if /^(day|latest)$/ =~ @mode
	result << "|<A HREF='#{h @update}?conf=default' ACCESSKEY='9'>9:設定</A>"
	result << "|"
	
	result
end

### contents plugins

# original: blog-category.rb $Revision: 1.14 $
# title for day mode
def categorized_title_of_day( day, title )
	cats, title = title_to_cats_title( title )
	if @mode == 'day'
		title = title.sub(/^(\[.+\])+/,'').gsub(/\s+/, ' ').strip
	else
		#title = title.sub(/^(\[.+\])+/,'').sub(/\(\d{4}\s?[\-\/年]\d\d?\s?[\-\/月]\s?.*\)/,'').gsub(/\s+/, ' ').strip
		title = title.sub(/^(\[.+\])+/,'').sub(/\(\d{4}[\-\/年]\s?\d\d?[\-\/月]\s?\d\d?日?\)/,'').gsub(/\s+/, ' ').strip
	end
	cats &= @index_catdays.keys if @hide_blank_paged_cat # リンク先がない場合は表示しない
	cats &= @menued_cats if @hide_no_menued_cat # メニューにないカテゴリは表示しない
	cats &= @mulpaged_cats if @hide_single_paged_cat # 単独ページは表示しない
	result = ''
	if @mode == 'day'
		result << title
	else
		result << diary_link( day: day, label: title, cat: @cat )
	end
	result
end

# original: html_anchor.rb
def anchor( s )
	if /^([\-\d]+)#?([pct]\d*)?$/ =~ s
		return diary_url( withoutindex: true, day: $1, cat: @cat, other: $2 )
	elsif /^\s*blogcategory=(.+)\s*$/ =~ s
		return diary_url( cat: $1 )
	else
		"" # ? s
	end
end

### body_footer

def body_footer( date )
	diary = get_diary( date )
	return '' unless diary
	
	result = ''
	cats = title_to_cats( diary.title )
	cats &= @index_catdays.keys # if @hide_blank_paged_cat # リンク先がない場合は表示しない
	cats &= @menued_cats if @hide_no_menued_cat # メニューにないカテゴリは表示しない
	cats &= @mulpaged_cats if @hide_single_paged_cat # 単独ページは表示しない
	
	dstrs = diary.title.scan(/\(.+?\)/)
	pub_date = get_date( dstrs ) || date
	
	if @mode == 'day' and !@conf.mobile_agent?
	result << <<-HTML
<div>
<span class='lm'>#{h navi_create_date}: #{date_fstr( pub_date )}</span>
<span class='lm'>#{h navi_lastmodified_date}: #{date_fstr( diary.last_modified )}</span>
</div>
<div>
<span class='category'>#{h navi_category}:#{cats_link( cats, ' ' )}</span>
</div>
	HTML
	elsif !@conf.mobile_agent?
	result << <<-HTML
<div>
<span class='lm'>#{h navi_create_date}: #{date_fstr( pub_date )}</span>
<span class='category'>#{h navi_category}:#{cats_link( cats, ' ' )}</span>
</div>
	HTML
	elsif @mode == 'day' and @conf.mobile_agent?
	result << <<-HTML
<p>
#{h navi_create_date}: #{date_fstr( pub_date )}<br>
#{h navi_lastmodified_date}: #{date_fstr( diary.last_modified )}<br>
#{h navi_category}:#{cats_link( cats, ' ' )}
</p>
	HTML
	elsif @conf.mobile_agent?
	result << <<-HTML
<p>
#{date_fstr( pub_date )} 
#{cats_link( cats, ' ' )}
</p>
	HTML
	else
	result << <<-HTML
<p>
#{date_fstr( pub_date )} 
#{date_fstr( diary.last_modified )} 
#{cats_link( cats, ' ' )}
</p>
	HTML
	end
	
	result
end

def navi_category
	"カテゴリ"
end

def navi_create_date
	"作成日"
end

def navi_lastmodified_date
	"更新日"
end

def date_fstr( date )
	"#{date.year}年#{date.month}月#{date.day}日"
end

### search plugin

def search_title
	q = @cgi.params['q'][0]
	if q and !q.empty?
		"簡単検索: #{h q} を含むタイトル一覧"
	else
		"最新のタイトル一覧"
	end
end

def menu_navi_search
	#他のsearch_titleがあれば、その search_title
	
	qword = @cgi.params['q'][0]
	nth = @cgi.params['n'][0].to_i
	search_limit = ( @conf['blex.search_limit'] || 25 ).to_i
	
	n = nth / search_limit
	n = 0 if n < 0
	n = @index_width if n > @index_width
	
	result = "<p>#{search_title}</p>"
	if n != 0
		result << "<hr style='clear:both'>"
		0.step( n, 1 ) { |i|
			result << "<p><a href='./?q=#{h qword}&n=#{i * search_limit}>#{i+1}</a></p>\n"
		}
	end
	result
end

def search_result( *dummy )
	qword = @cgi.params['q'][0]
	qword = nil if qword.empty?
	nth = @cgi.params['n'][0].to_i
	search_limit = ( @conf['blex.search_limit'] || 25 ).to_i
	date_format ||= @date_format
	cgi = CGI::new
	def cgi.referer; nil; end

	result = "<dl class='search-result'>\n"
	skip_count = ( nth / search_limit ) * search_limit
	count = 0
	
	result = ''
	catch(:exit) {
		@years.keys.sort.reverse_each { |yy|
			@years[yy].sort.reverse_each { |mm|
				cgi.params['date'] = ["#{yy}#{mm}"]
				m = TDiaryMonthWithoutFilter::new(cgi, '', @conf)
				m.diaries.keys.sort.reverse_each { |day|
					next if !m.diaries[day].visible?
					if qword.nil? or m.diaries[day].title.include?( qword ) or m.diaries[day].to_src.include?( qword )
						next if skip_count > count
						result << search_update( m.diaries[day], day ) 
						count += 1
						throw :exit if count > search_limit
					end
				}
			}
		}
	}
	result << "</dl>\n"
end

def search_update( mdiary, day )
	date_format = @date_format || '%Y-%m-%d'
	cats, title = title_to_cats_title( mdiary.title )
	pubday = mdiary.to_src.slice(/^\d{4}-\d\d-\d\d/) || ( day[0,4] + '-' + day[4,2] + '-' + day[6,2] )
	# ??? #{date.strftime( date_format )}
	"<dt>#{pubday} : #{cats_link(cats, '[', ']', ' ')}#{diary_link( day: day, label: title )}</dt>\n"
end

### resources ####################################


end 
### end of Blex class ////////////////////////////

### dispatchers and plugins ######################

### dispatchers for tDiary

if /^(preview|latest|month|day|append|replace|comment|showcomment|trackbackreceive|pingbackreceive)$/ =~ @mode and defined?(blog_category_cache_restore)
	cache = blog_category_cache_restore
	cache = nil if cache and cache.empty?
else
	cache = nil
end
begin
	@blex = Blex.new( @cgi, nil, @mode, @years, @date, cache, @conf, @logger )
rescue => @error
	@logger.fatal %Q{blex #{$!} (#{$!.class})\n#{$@.join( "\n" )}}
end

if @mode == 'latest'
	eval(<<-'MODIFY_CLASS', TOPLEVEL_BINDING)
		module TDiary
			class TDiaryLatest < TDiaryView
				def latest( limit = 5 )
					start = start_date
					limit = limit_size( limit )
					idx = 0

#					days = $diaries_days ? $diaries_days : @diaries.keys.sort.reverse # blex modified
					if $diaries_days
						days =  $diaries_days
						diaries =  $diaries
					elsif @diaries
						days = @diaries.keys.sort.reverse
						diaries =  @diaries
					else
						days = []
					end
					days.each do |date| # blex modified
						next if date > start
#						diary = @diaries[date]
						diary = diaries[date]
						next unless diary.visible?
						yield diary
						idx += 1
						break if idx >= limit
					end
				end
			end # class TDiaryLatest < TDiaryView
		end # module TDiary
	MODIFY_CLASS
end

### html header plugins

# css files
# 注意 mobile では、header_procは、働かない。挿入不要。

if /^(saveconf|conf)$/ !~ @mode
  adapter_css = @conf['blex.adapter_css'] || 'theme/blex-adapter.css'
  style_css = @conf['blex.style'] || 'style.css'
	add_header_proc do
		result = ''
		result << %Q{<link rel="stylesheet" href="#{adapter_css}" type="text/css" media="all">}
		result << %Q{<link rel="stylesheet" href="#{style_css}" type="text/css" media="all">}
		
		result
	end
end

# modify start and prev/next links in html header
alias :blex_index_page_tag :index_page_tag
def index_page_tag
	result = ''
	if @index_page and @index_page.size > 0 then
		result << "<link rel='index' title='#{h navi_index}' href='#{h @index_page}'>\n"
	end
	result << @blex.index_page_tag
	result << "<link rel='start' title='#{h navi_latest}' href='#{h @index}'>\n"
	result
end

### navigation plugins for PC and smart phone

def menu( )
	return '' unless /^(latest|month|day|search|comment|showcomment|trackbackreceive|pingbackreceive)$/ =~ @mode
	return 'DO NOT USE IN SECURE MODE' if @conf.secure

<<-HTML
<div class='blex_menu'>
<div class='tabs'>
#{@blex.menu_tabs}
</div>
<div style='clear:both;'></div>
<div class='navi'>
#{menu_navi}
</div>
</div>
<div style='clear:both;'></div>
HTML
end

def menu_navi

	#return '' if bot?
	result = ''
	case @mode
	when 'latest', 'day'
		result << menu_navi_day
	when 'search'
		result << menu_navi_search
	when 'edit'
		result << "<p>編集中</p>"
	when 'month'
		result << "<p>作成時期別表示 #{@day[0,4]}年 #{@day[4,2]}月頃</p>"
	else
		result << "<p>実行モード: #{@mode}</p>"
	end
	result
end

def menu_navi_day
	@blex.menu_navi_day
end

def menu_navi_search
	@blex.menu_navi_search
end

# footer navi for all media
def foot_navi
	footer_navi
end
def footer_navi
<<-HTML
<div style='clear:both;'></div>
<div class='blex_menu'>
<div class='navi'>
#{@blex.footer_navi}
</div>
</div>
<div style='clear:both;'></div>
HTML
end

#def side_menu; side_navi; end
def side_navi( klass=nil )
	return 'DO NOT USE IN SECURE MODE' if @conf.secure
	result = @blex.side_navi
	return '' if result.nil? or result.empty?
	
	if klass
	<<-HTML
<div class="#{klass}">
#{result}
</div>
	HTML
	else
		result
	end
end

alias :blex_navi_user_latest :navi_user_latest
def navi_user_latest
	''
end

alias :blex_navi_user_day :navi_user_day
def navi_user_day
	''
end

alias :blex_navi :navi
# original navi dispatch
def navi
	result =  %Q{<div class="adminmenu">}
	result << %Q{<span class="adminmenu"><a href="http://www.kohashi.org/dev/blex.html">blex(#{@mode})</a></span>\n} if @debug
#	result << %Q{<span class="adminmenu"><a href="#{@blex.diary_url( cat:$blex_start )}">#{$blex_label}</a></span>\n} if $blex_start
#	result << %Q{<span class="adminmenu"><a href="#{@blex.diary_url( day:@date, cat:@cgi.params['blogcategory'][0] )}">戻る</a></span>\n} if /^(edit|form|comment)$/ =~ @mode
	result << %Q{<span class="adminmenu"><a href="#{h @index}?n=0">最新</a></span>\n}
	edit = @conf['blex.edit'] || @update
	result << %Q{<span class="adminmenu"><a href="#{h edit}">追記</a></span>\n} if /^(day|latest)$/ =~ @mode
	result << %Q{<span class="adminmenu"><a href="#{h edit}?edit=true;year=#{@date.year};month=#{@date.month};day=#{@date.day}">編集</a></span>\n} if /^(day)$/ =~ @mode
	result << %Q{<span class="adminmenu"><a href="#{h @update}?conf=default">設定</a></span>\n}
	result << %Q{</div>}
	
	result
end


### navigation plugins for mobile

alias :blex_mobile_navi :mobile_navi
def mobile_navi
	result = ''
	result << @blex.mobile_navi
	result
end

def mobile_footer_navi
	result = ''
	result << @blex.mobile_footer_navi
	result
end

### contents plugins

# title link for latest mode
# dispatcher for blog-category.rb
def categorized_title_of_day( day, title )
	@blex.categorized_title_of_day( day, title )
end

# insert dates, tags on body end
def blex_body_footer( date )
	return '' if feed?
	@blex.body_footer( date )
end

add_body_leave_proc do |date|
	blex_body_footer( date )
end

# add blogcateory, serial date and html links for ordinary tDiary url
# original: html_anchor.rb
alias :blex_anchor :anchor
def anchor( s )
	@blex.anchor( s )
end

### search plugins

def search_title
#@logger.debug "blex :: search_title"
	@blex.search_title
end

def search_result
	@blex.search_result
end

